/*
  Copyright (C) 2000-2003 SKYRIX Software AG

  This file is part of OGo

  OGo is free software; you can redistribute it and/or modify it under
  the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation; either version 2, or (at your option) any
  later version.

  OGo is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
  License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with OGo; see the file COPYING.  If not, write to the
  Free Software Foundation, 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.
*/
// $Id: WOContext+Cursor.h,v 1.2 2003/07/11 17:12:51 jan Exp $

#ifndef __WOContext_Cursor_H__
#define __WOContext_Cursor_H__

#include <NGObjWeb/WOContext.h>

/*
  Cursors are used by evaluating bindings. The default-cursor is always the
  active context component, so the default behaviour is like in WO.
  
  Cursors are useful for reducing the need for those 'item' bindings.
*/

@interface WOContext(Cursor)

- (void)pushCursor:(id)_cursor;
- (id)popCursor;
- (id)cursor;

@end

#endif /* __WOContext_Cursor_H__ */
