/*
  Copyright (C) 2000-2003 SKYRIX Software AG

  This file is part of OGo

  OGo is free software; you can redistribute it and/or modify it under
  the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation; either version 2, or (at your option) any
  later version.

  OGo is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
  License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with OGo; see the file COPYING.  If not, write to the
  Free Software Foundation, 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.
*/
// $Id: WOTemplateBuilder.h,v 1.2 2003/07/11 17:12:51 jan Exp $

#ifndef __NGObjWeb_WOTemplateBuilder_H__
#define __NGObjWeb_WOTemplateBuilder_H__

#import <Foundation/NSObject.h>
#include <NGObjWeb/WOElement.h>

@class NSURL, NSDate, NSString, NSDictionary, NSMutableDictionary;
@class NSEnumerator;
@class WOTemplate, WOSubcomponentInfo, WOComponentScript;

@interface WOTemplateBuilder : NSObject
{
}

+ (WOTemplateBuilder *)templateBuilderForPath:(NSString *)_path;
+ (WOTemplateBuilder *)templateBuilderForURL:(NSURL *)_url;

- (WOTemplate *)buildTemplateAtURL:(NSURL *)_url;

@end

#include <NGObjWeb/WOTemplate.h>
#include <NGObjWeb/WOComponentScript.h>

#endif /* __NGObjWeb_WOTemplateBuilder_H__ */
