/*
  Copyright (C) 2000-2003 SKYRIX Software AG

  This file is part of OGo

  OGo is free software; you can redistribute it and/or modify it under
  the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation; either version 2, or (at your option) any
  later version.

  OGo is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
  License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with OGo; see the file COPYING.  If not, write to the
  Free Software Foundation, 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.
*/
// $Id: OFSFileRenderer.h,v 1.2 2003/07/11 17:12:51 jan Exp $

#ifndef __SoOFS_OFSFileRenderer_H__
#define __SoOFS_OFSFileRenderer_H__

#import <Foundation/NSObject.h>

/*
  OFSFileRenderer
  
  Renders the actual contents of a file without any evaluation (eg used for
  delivering images stored in OFS)
*/

@class NSException;
@class WOContext;

@interface OFSFileRenderer : NSObject
{
}

+ (id)sharedRenderer;

/* rendering */

- (NSException *)renderObject:(id)_object inContext:(WOContext *)_ctx;
- (BOOL)canRenderObject:(id)_object inContext:(WOContext *)_ctx;

@end

#endif /* __SoOFS_OFSFileRenderer_H__ */
